sequenceDiagram
autonumber
participant shopper as Shopper
participant storefront as Storefront <br/> (Browser)
participant epages6 as ePages6 <br/> (Cartridges)
participant epagesj as ePagesJ
participant mollie as Mollie

Note over shopper, epages6:Shopper is on the checkout Payment Selection Page
shopper->>storefront: Chooses a Mollie Payment method
shopper->>storefront: Clicks "Continue"

Note over shopper, epages6:Shopper is on the Buy confirmation page
shopper->>storefront: Clicks "Buy" <br> checkoutconfirmation.js / onBuyButtonClick
storefront->>epages6: Create Mollie Order <br> UI::JSON::OrderCreationMolliePayments
epages6->>epagesj: Create Mollie Order <br> POST "payments/mollie/v2/orders"
epagesj->>mollie: Create Mollie Order <br> POST "https:/api.mollie.com/v2/orders"
mollie-->>epagesj: Return Mollie Order
epagesj-->>epages6: Return Mollie Order
epages6-->>storefront: Return Mollie checkout url<br> checkoutconfirmation.js / onSuccessfulMollieOrderCreationResponse
storefront->>mollie: Redirect to Mollie checkout url

Note over shopper, mollie:Shopper is on Mollie Hosted Payment Page
shopper->>mollie: Shopper fills the payment details and clicks "Buy"  

alt Mollie Webhook is triggered (Status paid)

mollie-->>epages6: Mollie calls payment Webhook <br> UI::Shop::MolliePaymentsPaymentWebhook
epages6->>epagesj: Get Order and payment details <br> GET "payments/mollie/v2/orders/{orderId}"
epagesj->>mollie: Get Order and payment details <br> GET "https://api.mollie.com/v2/orders/{orderId}"
mollie-->>epagesj: Return Order and payment details
epagesj-->>epages6: Return Order and payment details
epages6->>epages6: Update LineItemPayment status and refund amounts
epages6->>epagesj: Update order number in Mollie <br> PUT "payments/mollie/v2/orders/{orderId}"
epagesj->>mollie: Update order number in Mollie <br> PATCH "https://api.mollie.com/v2/orders/{orderId}"
mollie-->>epagesj: Return Order details
epagesj-->>epages6: Return Order details
epages6->>epages6: Do Basket2Order
epages6->>mollie: Return 200 Ok
mollie-->>epages6: Redirect to ePages <br> UI::LineItemPaymentMolliePayments::RedirectCheckoutMolliePayments

else Mollie Webhook is not triggered (Statuses authorized, pending)

mollie-->>epages6: Redirect to ePages <br> UI::LineItemPaymentMolliePayments::RedirectCheckoutMolliePayments
epages6-->>storefront: Redirect to Buy Confirmation Page
Note over shopper, epages6:Shopper is back on the Buy confirmation page
storefront->>epages6: Basket form gets automatically submitted
epages6->>epages6: Hook AfterSaveMultiCheckoutConfirmation <br> UI::BasketOrder::ValidateOrderPaymentStatus
epages6->>epagesj: Get Order and payment details <br> GET "payments/mollie/v2/orders/{orderId}"
epagesj->>mollie: Get Order and payment details <br> GET "https://api.mollie.com/v2/orders/{orderId}"
mollie-->>epagesj: Return Order and payment details
epagesj-->>epages6: Return Order and payment details
epages6->>epages6: Update LineItemPayment status
epages6->>epagesj: Update order number in Mollie <br> PUT "payments/mollie/v2/orders/{orderId}"
epagesj->>mollie: Update order number in Mollie <br> PATCH "https://api.mollie.com/v2/orders/{orderId}"
mollie-->>epagesj: Return Order details
epagesj-->>epages6: Return Order details
end

epages6-->>storefront: Redirect to Order Confirmation Page
Note over shopper, epages6:Shopper is presented with a successful order confirmation page
