sequenceDiagram
autonumber
participant Merchant as Merchant
participant MBO as Merchant Backoffice <br/> (Browser)
participant epages6 as ePages6 <br/> (Cartridges)
participant epagesj as ePagesJ
participant Mollie as Mollie

epages6-->>MBO: build onboarding url <br> API::MolliePaymentsUrlBuilder::buildConnectAndReconnectUrl
Note over Merchant, epages6:Merchant is on MBO Payments: Mollie Payment settings page <br> UI::PaymentMethodMolliePayments::ViewSettings
Merchant->>MBO: Clicks "Connect with Mollie"
MBO->>Mollie: Redirection to Mollie onboarding url (with app client_id)

Note over Merchant, Mollie:Merchant gets presented with Mollie App permission form
Merchant->>Mollie: Merchant clicks "Allow access" on form to authorize the app
Mollie-->>epages6: returns the Authorization code<br> UI::MolliePayments::BacklinkMolliePaymentsOnboarding
epages6->>epages6: Redirect to Mollie Payment ViewSettings Page
epages6->>epagesj: Get Access Token <br> POST "payments/mollie/v2/tokens"
epagesj->>Mollie: Exchange the Authorization code for an Access Token <br> POST "https://api.mollie.com/oauth2/tokens"
Mollie-->>epagesj: return Access Token and Refresh Token
epagesj-->>epages6: return Access Token and Refresh Token
epages6->>epagesj: Get Website Profiles <br> GET "payments/mollie/v2/profiles"
epagesj->>Mollie: Get Website Profiles <br> GET "https://api.mollie.com/v2/profiles"
Mollie-->>epagesj: return Website Profiles
epagesj-->>epages6: return Website Profiles


Note over Merchant, epages6:Merchant is on MBO Payments: Mollie Payment settings page <br> UI::PaymentMethodMolliePayments::ViewSettings
Merchant->>MBO: Choose Website Profile  <br> mbosettings.js / getEnabledPaymentMethods
MBO->>epages6: Get Payment Methods <br> UI::JSON::GetMolliePaymentsMethods
epages6->>epagesj: Get Payment Methods <br> GET "payments/mollie/v2/methods"
epagesj->>Mollie: Get Payment Methods <br> GET "https://api.mollie.com/v2/methods"
Mollie-->>epagesj: return Payment Methods
epagesj-->>epages6: return Payment Methods
epages6-->>MBO: return Payment Methods <br> mbosettings.js / onPaymentMethodsResponse
Merchant->>MBO: Choose Payment Method