sequenceDiagram
autonumber
participant merchant as Merchant
participant mbo as Merchant Backoffice <br/> (Browser)
participant epages6 as ePages6 <br/> (Cartridges)
participant epagesj as ePagesJ
participant mollie as Mollie


Note over merchant, epages6: Merchant is on MBO Orders: Order details page <br> (Payment Status Authorized)
opt This step will trigger the logic to update the Mollie Order 
 merchant->>mbo: Merchant updates some prices and deletes other lineItemProducts 
end
merchant->>mbo: Merchant checks "Shipping delivered"
merchant->>mbo: Merchant clicks "Save" button


Note over merchant, epages6: Merchant gets shown "Shipment and capture" dialog
merchant->>mbo: Clicks "Capture" button <br> INC-OrdersShipments.html / handleOrderShipmentAJAX
mbo->>epages6: Create shipment and capture <br> UI::JSON::OrderShipmentMolliePayments
opt Logic to update the Mollie Order
loop For each LineItemProduct that might be changed by Merchant 
    epages6->>epagesj: Update lineItem on Mollie Order <br> PUT "payments/mollie/v2/orders/{orderId}/lines"
    epagesj->>mollie: Update lineItem on Mollie Order <br> PATCH "payments/mollie/v2/orders/{orderId}/lines/{orderLineId}"
    mollie-->>epagesj: returns OK_200
    epagesj-->>epages6: returns OK_200
    epages6->>epages6: Collect deleted LineItemProduct
end
epages6->>epagesj: Delete lineItems from Mollie Order <br> DELETE "payments/mollie/v2/orders/{orderId}/lines/{orderLineId}"
    epagesj->>mollie: Delete lineItems from Mollie Order <br> DELETE "https://api.mollie.com/v2/orders/{orderId}/lines"
mollie-->>epagesj: returns NO_CONTENT_204
epagesj-->>epages6: returns NO_CONTENT_204
end

epages6->>epagesj: Create shipment and capture <br> POST "payments/mollie/v2/orders/{orderId}/shipments"
epagesj->>mollie: Create shipment and capture <br> POST "https://api.mollie.com/v2/orders/{orderId}/shipments"
mollie-->>epagesj: returns Order shipment Response
epagesj-->>epages6: returns Order shipment Response
epages6->>epagesj: Get Order and payment details <br> GET "payments/mollie/v2/orders/{orderId}"
epagesj->>mollie: Get Order and payment details <br> GET "https://api.mollie.com/v2/orders/{orderId}"
mollie-->>epagesj: return Order and payment details
epagesj-->>epages6: return Order and payment details
epages6->>epages6: Update LineItemPayment Status and refunds
epages6-->>mbo: returns Order shipment Response <br> INC-OrdersShipments.html / handleOrderShipmentAJAX

Note over merchant, epages6: Merchant gets shown "Shipment and capture Successful"
merchant->>mbo: Click "Ok"
mbo->>epages6: Submit form to ePages6
